<!doctype html>
<html lang='en'>

<head>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1, shrink-to-fit=no'>
  <meta name='description' content=''>
  <meta name='author' content=''>
  <link rel="icon" type="image/x-icon" href="favicon.ico" />

  <title>CAE Data Management System</title>

  <!-- Bootstrap core CSS -->
  <link href='bootstrap/css/bootstrap.min.css' rel='stylesheet'>
  <link href='css/mystyle.css' rel='stylesheet'>


  <!-- Custom styles for this template -->
  <link href='css/offcanvas.css' rel='stylesheet'>
  <script language='javascript' type='text/javascript' src='js/lsd.js'></script>
  <script language='javascript' type='text/javascript' src='js/lsdxmlhttp.js'></script>
  <script src='assets/js/vendor/jquery-slim.min.js' crossorigin='anonymous'></script>
  <script src='js/angular.min.js'></script>
  <script src='js/caeangular.js'></script>
  <script src='assets/js/vendor/popper.min.js'></script>
  <script src='bootstrap/js/bootstrap.min.js'></script>
  <script src='js/offcanvas.js'></script>
</head>

<body ng-app="CAEApp">

  <nav class='navbar navbar-expand-md fixed-top navbar-dark sim_header' style="background-color:#007bff">
    <a class='navbar-brand' href='dashboard.php' style="color:black">Dashboard</a>
    <button class='navbar-toggler' type='button' data-toggle="collapse" data-target='#navbarsExampleDefault'
      aria-controls='navbarsExampleDefault' aria-expanded='false' aria-label='Toggle navigation'>
      <span class='navbar-toggler-icon'></span>
    </button>

    <div class='collapse navbar-collapse' id='navbarsExampleDefault'>
      <ul class='navbar-nav mr-auto'>
        <li class='nav-item active'>
          <a class='navbar-brand nav-link' href='workingmodel.html' style="color:white"
            onMouseOver="this.style.color='black'" onMouseOut="this.style.color='white'">3D Model<span
              class='sr-only'>(current)</span></a>
        </li>
        <li class='nav-item'>
          <a class='navbar-brand nav-link' href='download.html' style="color:white"
            onMouseOver="this.style.color='black'" onMouseOut="this.style.color='white'">Download</a>
        </li>
        <li class='nav-item'>
          <a class='navbar-brand nav-link' href='about.html' style="color:white" onMouseOver="this.style.color='black'"
            onMouseOut="this.style.color='white'">About</a>
        </li>
      </ul>
      <form class='form-inline my-2 my-lg-0'>
        <div>
          <ul class='navbar-nav mr-auto'>
            <li class='nav-item active'>
              <a href='upload.html' onMouseOver="this.style.color='black'" onMouseOut="this.style.color='white'"
                class="navbar-brand nav-link" style="color:white;">Upload</a>
            </li>
            <li class='nav-item'>
              <a href='submittosolver.php' class="navbar-brand nav-link" style="color:white"
                onMouseOver="this.style.color='black'" onMouseOut="this.style.color='white'">Submit to Solver</a>
            </li>
            <li class='nav-item'>
              <a href='viewresults.html' class="navbar-brand nav-link" style="color:white"
                onMouseOver="this.style.color='black'" onMouseOut="this.style.color='white'">View Results</a>
            </li>
            <li class='nav-item'>
              <select class='form-control' id="SearchType" style="margin-right: 5px;margin-left: 10px;">
                <option>Models</option>
                <option>Keywords</option>
                <option>Fields</option>
              </select>
            </li>
            <li class='nav-item'>
              <input class='form-control mr-sm-2' type='text' placeholder='Search' aria-label='Search'>
            </li>
            <li class='nav-item'>
            <a href='logout.php' class="navbar-brand nav-link" style="color:orange"
                onMouseOver="this.style.color='red'" onMouseOut="this.style.color='orange'">
              <?php 
                  if(isset($_SESSION['user_id'])) 
                      echo $_SESSION['user_id'];
                  else
                  {
                      header("Location: index.php");
                      exit;
                  }
              ?>
              <img src="img/signout.jpg" style="color:orange;width:32px;height:32px"/>
              </a>
            </li>
          </ul>
        </div>
      </form>
    </div>
  </nav>

  <main role='main' class='container-float' ng-controller="modelImageController">
    <div class='row'>
      <div class='col-12'>
        <table class="table table-responsive w-auto">
            <tr ng-repeat="m in combinedModelList track by $index" ng-if="$index % 4 == 0">
              <td colspan="2">
                <a data-toggle="modal" data-target="#details{{$index}}" ng-href="#details{{m.path}}" ng-click="onModelDetailsClick(m.name)">{{m.path}}</a>
                <div class="modal" id="details{{$index}}">
                  <div class="modal-dialog modal-md" role="dialog">
                    <div class="modal-content rounded-4 shadow">
                        <div class="modal-header">
                        <button type="button" class="btn-close" data-dismiss="modal">&times;</button>
                            <h5 class="fw-bold">{{m.path}}</h5>
                        </div>
                        <div class="modal-body">
                            <table class="table table-sm table-striped">
                              <tr ng-repeat="kwDetail in kwDetailList track by $index">
                                <td style="font-size:16px">{{kwDetail}}</td>
                                <td style="font-size:16px">{{kwCountList[$index]}}</td>
                              </tr>
                            </table>
                        </div>
                    </div>
                  </div>
                </div>
                <a href="workingmodel.html">
                <img class="autoResizeImage" ng-src="{{baseDir+m.name+'/'+m.name+'.jpeg'}}" ng-click="onModelClick(m.name)">
                </a>
              </td>
              <td colspan="2">
              <a data-toggle="modal" data-target="#details{{$index+1}}" ng-href="#details{{combinedModelList[$index+1].path}}" ng-click="onModelDetailsClick(combinedModelList[$index+1].name)">{{combinedModelList[$index+1].path}}</a>
                <div class="modal" id="details{{$index+1}}">
                  <div class="modal-dialog modal-md" role="dialog">
                    <div class="modal-content rounded-4 shadow">
                        <div class="modal-header">
                        <button type="button" class="btn-close" data-dismiss="modal">&times;</button>
                            <h5 class="fw-bold">{{combinedModelList[$index+1].path}}</h5>
                        </div>
                        <div class="modal-body">
                            <table class="table table-sm table-striped">
                              <tr ng-repeat="kwDetail in kwDetailList track by $index">
                                <td style="font-size:16px">{{kwDetail}}</td>
                                <td style="font-size:16px">{{kwCountList[$index]}}</td>
                              </tr>
                            </table>
                        </div>
                    </div>
                  </div>
                </div>
                <!--a ng-href="{{combinedModelList[$index+1].path}}" ng-click="onModelDetailsClick(combinedModelList[$index+1].name)">{{combinedModelList[$index+1].path}}</a-->
                <a href="workingmodel.html">
                <img class="autoResizeImage" ng-src="{{baseDir+combinedModelList[$index+1].name+'/'+combinedModelList[$index+1].name+'.jpeg'}}" ng-click="onModelClick(combinedModelList[$index+1].name)">
                </a>
              </td>
              <td colspan="2">
              <a data-toggle="modal" data-target="#details{{$index+2}}" ng-href="#details{{combinedModelList[$index+2].path}}" ng-click="onModelDetailsClick(combinedModelList[$index+2].name)">{{combinedModelList[$index+2].path}}</a>
                <div class="modal" id="details{{$index+2}}">
                  <div class="modal-dialog modal-md" role="dialog">
                    <div class="modal-content rounded-4 shadow">
                        <div class="modal-header">
                        <button type="button" class="btn-close" data-dismiss="modal">&times;</button>
                            <h5 class="fw-bold">{{combinedModelList[$index+2].path}}</h5>
                        </div>
                        <div class="modal-body">
                            <table class="table table-sm table-striped">
                              <tr ng-repeat="kwDetail in kwDetailList track by $index">
                                <td style="font-size:16px">{{kwDetail}}</td>
                                <td style="font-size:16px">{{kwCountList[$index]}}</td>
                              </tr>
                            </table>
                        </div>
                    </div>
                  </div>
                </div>
                <!--a ng-href="{{combinedModelList[$index+2].path}}" ng-click="onModelDetailsClick(combinedModelList[$index+2].name)">{{combinedModelList[$index+2].path}}</a-->
                <a href="workingmodel.html">
                <img class="autoResizeImage" ng-src="{{baseDir+combinedModelList[$index+2].name+'/'+combinedModelList[$index+2].name+'.jpeg'}}" ng-click="onModelClick(combinedModelList[$index+2].name)">
                </a>
              </td>
              <td colspan="2">
              <a data-toggle="modal" data-target="#details{{$index+3}}" ng-href="#details{{combinedModelList[$index+3].path}}" ng-click="onModelDetailsClick(combinedModelList[$index+3].name)">{{combinedModelList[$index+3].path}}</a>
                <div class="modal" id="details{{$index+3}}">
                  <div class="modal-dialog modal-md" role="dialog">
                    <div class="modal-content rounded-4 shadow">
                        <div class="modal-header">
                        <button type="button" class="btn-close" data-dismiss="modal">&times;</button>
                            <h5 class="fw-bold">{{combinedModelList[$index+3].path}}</h5>
                        </div>
                        <div class="modal-body">
                            <table class="table table-sm table-striped">
                              <tr ng-repeat="kwDetail in kwDetailList track by $index">
                                <td style="font-size:16px">{{kwDetail}}</td>
                                <td style="font-size:16px">{{kwCountList[$index]}}</td>
                              </tr>
                            </table>
                        </div>
                    </div>
                  </div>
                </div>
                <!--a ng-href="{{combinedModelList[$index+3].path}}" ng-click="onModelDetailsClick(combinedModelList[$index+3].name)">{{combinedModelList[$index+3].path}}</a-->
                <a href="workingmodel.html">
                <img class="autoResizeImage" ng-src="{{baseDir+combinedModelList[$index+3].name+'/'+combinedModelList[$index+3].name+'.jpeg'}}" ng-click="onModelClick(combinedModelList[$index+3].name)">
                </a>
              </td>
            </tr>
          </table>
      </div>
      <!--/span-->
    </div>
  </main>
  <!--/.container-->

  <p>&copy; CAE Database 2023</p>


  <!-- Bootstrap core JavaScript
    ================================================== -->
  <!-- Placed at the end of the document so the pages load faster -->



</body>

</html>
