<?php
/** Fetches available databases for a particular user excluding the
  * system tables
  * @param my_sql_con [in] database connection
  * @param db_array [out] list of databases queried
  */
function getDBs(&$mysql_con, &$db_array)
{
   $my_dbs = mysqli_query($mysql_con, "show databases;");

   if( $my_dbs == false )
   {
      echo "Query failed for database 1 <br>";
      return;
   }

   $num_rows = mysqli_num_rows($my_dbs);
   //echo "DBS=" . $num_rows . "\n";
   //$db_array = Array();
   for($i = 0; $i < $num_rows; $i++)
   {
      $db_list = mysqli_fetch_row($my_dbs);
      if( $db_list[0] == 'information_schema' || $db_list[0] == 'mysql' || $db_list[0] == 'performance_schema' || $db_list[0] == 'sys')
	 continue;
      array_push($db_array, $db_list[0]);
      //echo "DBNAME=" . $db_list[0] . "\n";
   }
   mysqli_free_result($my_dbs);
   asort($db_array);
}

/** Fetches model names for a given databse
  * @param mysql_con [in] Database connection
  * @param db_name [in] Database name in particular
  * @param model_array [out] List of Model names
  */
function getModelsList(&$mysql_con, &$db_name, &$model_array, &$model_path_array)
{
   //locates all node tables inside the database as for any model
   //nodes are the basic need.
   //$qry_str = "show table status like '%\_\_\_%';";
   $qry_str = "show table status like '%MAIN%';";
   $local_model_array = [];
   getModelArray($mysql_con, $db_name, $qry_str, $local_model_array);

   $old_model_array = [];
   $hash_str = "";
   foreach($local_model_array as $model)
   {
      $hash = str_replace("MAIN", "", $model);
      if(is_numeric($hash))
          $hash_str .= $hash . ",";
      else
      {
          $qry = "select model_uuid from cae_models_list where model_name=\"$model\";";
          $my_results = mysqli_db_query($db_name, $qry, $mysql_con);
	  $num_rows = mysqli_num_rows($my_results);
	  if($num_rows === 0)
	  {
	      $hashval = crc32($model);
	      $insert_qry = "insert into `cae_models_list` values(NULL, \"$hash\", \"$model\", \"kmarichetty@yahoo.com\", $hashval, 1);";
              $my_results = mysqli_db_query($db_name, $insert_qry, $mysql_con);
              $hash_str .= $hashval . ",";	
	      $old_model_array["$hashval"] = $model;
	  }
	  else
	  {
              $row = mysqli_fetch_row($my_results);
              $hash_str .= $row[0] . ",";	
	      $hashval = $row[0];
	      $old_model_array["$hashval"] = $model;
	  }
      }
   }
   $hash_str = rtrim($hash_str, ",");
   $hash_str = "(" . $hash_str . ")";
   $qry_str = "select model_path,model_uuid from `cae_models_list` where model_uuid in $hash_str;";
   //echo $qry_str . "\n";
   $my_results = mysqli_db_query($db_name, $qry_str, $mysql_con);
   $num_rows = mysqli_num_rows($my_results);

   $array_keys_list = array_keys($old_model_array);
   for($i = 0; $i < $num_rows; $i++)
   {
      $row = mysqli_fetch_row($my_results);
      $str_list = explode("/", $row[0]);
      $str_count = count($str_list);
      if($str_count > 1)
         $model_path = $str_list[$str_count-2] . "/" . $str_list[$str_count-1];
      else
         $model_path = $row[0];
      array_push($model_path_array, $model_path);
      $key_found = array_search($row[1], $array_keys_list);
      if($key_found !== FALSE)
      {
	  $key = $row[1];
	  $model_name = $old_model_array["$key"];
      }
      else
          $model_name = $row[1] . "MAIN";
      array_push($model_array, $model_name);
   }

   //locates all include tables inside the database as for some models
   //nodes are included in include files
/*
   $qry_str = "show table status like '%___INCLUDES';";
   getModelArray($mysql_con, $db_name, $qry_str, $model_array);
*/
   //asort($model_array);
}

function getModelArray(&$mysql_con, &$db_name, &$qry_str, &$model_array)
{
   $my_tabs = mysqli_db_query($db_name, $qry_str, $mysql_con);

   if( $my_tabs == false )
   {
      echo "Query failed for database $db_name 2<br>";
      return;
   }

   $num_rows = mysqli_num_rows($my_tabs);
   $temp_array = Array();
   for($i = 0; $i < $num_rows; $i++)
   {
      $row = mysqli_fetch_row($my_tabs);
      $loc = strpos($row[0], "___");
      $model = substr($row[0], 0, $loc);
      array_push($temp_array, $model);
   }

   $m_array = array_unique($temp_array);
   foreach($m_array as $m)
      array_push($model_array, $m);
   mysqli_free_result($my_tabs);
}

function getModelDetails(&$mysql_con, &$db_name, &$model_name, &$ent_list)
{
   $qry_str = "show table status like '$model_name" . "\_\_\_%';";
   $my_tabs = mysqli_db_query($db_name, $qry_str, $mysql_con);
   if( $my_tabs == false )
   {
      echo "Query failed for database $db_name 3<br>";
      return;
   }

   $num_rows = mysqli_num_rows($my_tabs);
   $tab_array = Array();
   for($i = 0; $i < $num_rows; $i++)
   {
      $row = mysqli_fetch_row($my_tabs);
      array_push($tab_array, $row[0]);
   }
   mysqli_free_result($my_tabs);

   foreach($tab_array as $tab_name)
   {
      $loc1 = strpos($tab_name, "___");
      if( $loc1 == -1 )
	 continue;
      //$loc2 = strpos($tab_name, "_TABLE");
      //if( $loc2 == -1 )
	 //continue;
      $loc1 = $loc1 + 3;
      //$ent = substr($tab_name, $loc1, $loc2-$loc1);
      $ent = substr($tab_name, $loc1);
      switch($ent)
      {
	 case 'NODES':
	 {
	    $qry_str = "select count(card_index) from `$tab_name`;";
	    $my_tabs = mysqli_db_query($db_name, $qry_str, $mysql_con);
	    if( $my_tabs == false )
	    {
	       echo "Query failed for nodes in $db_name 4<br>";
	       return;
	    }

            $row = mysqli_fetch_row($my_tabs);
	    //$num_rows = mysqli_num_rows($my_tabs);
	    $ent_list['*NODES'] = $row[0];
	    mysqli_free_result($my_tabs);
	 }
	 break;
	 case 'ELEMENTS':
	    getElementsDetails($mysql_con, $db_name, $tab_name, $ent_list);
	 break;
         default:
	 {
	    $qry_str = "select count(card_index) from `$tab_name` where value1='$';";
	    $my_tabs = mysqli_db_query($db_name, $qry_str, $mysql_con);
	    if( $my_tabs == false )
	    {
	       echo "Query failed for nodes in $db_name 5<br>";
	       return;
	    }
	    //$num_rows = mysql_num_rows($my_tabs);
            $row = mysqli_fetch_row($my_tabs);
	    $ent_list["*$ent"] = $row[0];
	    mysqli_free_result($my_tabs);
	 }
         break;
      }
   }
}

function getElementsDetails(&$mysql_con, &$db_name, &$tab_name, &$ent_list)
{
   include( 'lsdyna/element/element_array.php');

   $qry_str = "select kw_type from `$tab_name` group by kw_type;";
   $elm_types = mysqli_db_query($db_name, $qry_str, $mysql_con);
   if( $elm_types == false )
   {
      echo "Query failed for element types in $db_name 6<br>";
      echo mysqli_error() . "<br>";
      return;
   }
   $num_rows = mysqli_num_rows($elm_types);
   $type_array = Array();
   for($i = 0; $i < $num_rows; $i++)
   {
      $row = mysqli_fetch_row($elm_types);
      array_push($type_array, $row[0]);
   }
   mysqli_free_result($elm_types);
   foreach($type_array as $elm_type)
   {
      $qry_str = "select count(card_index) from `$tab_name` where kw_type='$elm_type';";
      $elm_list = mysqli_db_query($db_name, $qry_str, $mysql_con);
      if( $elm_list == false )
      {
	 echo "Query failed for element type count in $db_name 8<br>";
         echo mysqli_error() . "<br>";
	 return;
      }
      //$num_rows = mysql_num_rows($elm_list);
      $row = mysqli_fetch_row($elm_list);
      $ent_name = "ELM_" . "$elm_type";
      $ent_type = array_search($ent_name, $element_array);
      $ent_list["*$ent_type"] = $row[0];
      mysqli_free_result($elm_list);
   }
}

/** finding the available DB tables from the model name and getting the kws
    from the table names like C1500_NODES. we get here NODE as the kw_type */
function getModelKWs(&$mysql_con, &$db_name, &$model_name, &$ent_list)
{
   $qry_str = "show table status like '$model_name" . "\_\_\_%';";
   $my_tabs = mysqli_db_query($db_name, $qry_str, $mysql_con);
   if( $my_tabs == false )
   {
      echo "Query failed for database $db_name 7<br>";
      return;
   }

   $num_rows = mysqli_num_rows($my_tabs);
   for($i = 0; $i < $num_rows; $i++)
   {
      $row = mysqli_fetch_row($my_tabs);
      $loc1 = strpos($row[0], "___");
      if( $loc1 == -1 )
	 continue;
      //$loc2 = strpos($row[0], "_TABLE");
      //if( $loc2 == -1 )
	 //continue;
      $loc1 += 3;
      //$ent = substr($row[0], $loc1, $loc2-$loc1-1);
      $loc2 = strlen($row[0])-1;
      $ent = substr($row[0], $loc1, $loc2-$loc1);
      array_push($ent_list, "$ent");
   }
   mysqli_free_result($my_tabs);
}
function getJSKWString(&$src_type, &$db_name, &$model_name, &$mysql_con, &$js_str)
{
   $ent_list = Array();
   getModelDetails($mysql_con, $db_name, $model_name, $ent_list);

   $str = "var names_list=[''";
   $str1 = "var values_list=[''";
   $i = 0;
   if( count($ent_list) )
   {
      $ent_keys = array_keys($ent_list);
      $ent = $ent_keys[0];

      $str = "var names_list=['$ent -- " . $ent_list[$ent] . "'";
      $str1 = "var values_list=['$ent'";
      $i = 1;
   }

   for(;$i < count($ent_keys); $i++)
   {
      $ent = $ent_keys[$i];
      $str .= ",'$ent -- " . $ent_list[$ent] . "'";
      $str1 .= ",'$ent'";
   }
  
   $str .= "];\n";
   $str1 .= "];\n";

   $js_str .= $str;
   $js_str .= $str1;
   $js_str .= "var options=document.moveDetailsForm." . $src_type . "EntList.options;";
   $js_str .= "modifyKWList(options,names_list,values_list);";
}
?>
