/*global angular */
'use strict';

/**
 * The main app module
 * @name app
 * @type {angular.Module}
 */
var app = angular.module('app', ['flow'])
.config(['flowFactoryProvider', function (flowFactoryProvider) {
  flowFactoryProvider.defaults = {
    target: function (FlowFile, FlowChunk, isTest) {
            var results_flag = document.getElementById("ResultsFlag").checked;
            if(FlowFile.MainFile != undefined)
                return "upload.php?MainFile=" + FlowFile.MainFile + "&ResultsFlag=" + results_flag;
            else
            {
                var model_name = document.getElementById("MainFile").value;
                if(model_name != undefined && model_name != "")
                {
                    console.log("MAIN FILE=" + model_name);
                    return "upload.php" + "?MainFile=" + model_name  + "&ResultsFlag=" + results_flag;
                }
                else
                    return "upload.php" + "?ResultsFlag=" + results_flag;
            }
},
    permanentErrors: [404, 500, 501],
    maxChunkRetries: 1,
    chunkRetryInterval: 5000,
    simultaneousUploads: 4
  };
  flowFactoryProvider.on('catchAll', function (event) {
    console.log('catchAll', arguments);
    if(arguments.length > 1)
    {
      if(arguments[0] == "fileSuccess")
      {
        var elm = document.getElementById("testElm");
         if( elm && arguments.length > 2)
	          elm.innerHTML = arguments[2];
      }
      else if(arguments[0] == 'fileRemoved')
      {
        var elm = document.getElementById("testElm");
         if( elm )
	          elm.innerHTML = "";
      }
    }
  });
  // Can be used with different implementations of Flow.js
  // flowFactoryProvider.factory = fustyFlowFactory;
}]);
