var CAEApp = angular.module("CAEApp", []);

CAEApp.factory('ModelsService', ['$http', function($http) {
    var modelService = {};
    modelService.jsDataDir = "";
    modelService.SelectedModel = "";
    modelService.SelectedResultModel = "";
    modelService.getModelList = function(selModel) {
           var url = "getmodels.php";
           if(selModel != undefined && selModel != "")
           {
              url = "getmodels.php?ModelName=" + selModel;
              modelService.SelectedModel = selModel;
           }

	   var promise = $http.get(url);
           
	   promise.then(function(response) {
	      console.log("ModelList=" + response.data.ModelList);
              return response;
	   },
	   function(response) {
	      console.log("ERROR=" + response.message);
	   },
           function(response) {
	      console.log("ERROR=" + response.message);
           });

           return promise;
   }

   modelService.getModelDetails = function(selModel) {
      var url = "getmodeldetails.php";
      if(selModel != undefined && selModel != "")
         url = "getmodeldetails.php?ModelName=" + selModel;

      var promise = $http.get(url);
            
      promise.then(function(response) {
         console.log("DetailList=" + response.data.kwDetailList);
               return response;
      },
      function(response) {
         console.log("ERROR=" + response.message);
      },
      function(response) {
         console.log("ERROR=" + response.message);
      });

      return promise;
   }
   
   modelService.getPartList = function(dataDir) {
      var url = this.jsDataDir + "/partdetails.js.gz";
      if(dataDir != undefined && dataDir != "")
         url = dataDir + "/partdetails.js.gz";
      var promise = $http.get(url);

      promise.then(function(response) {
         //console.log("PartList=" + response.data);
         modelService.PDArray = response.data.PDArray;
              return response;
	   },
	   function(response) {
	      console.log("ERROR=" + response.message);
	   },
           function(response) {
	      console.log("ERROR=" + response.message);
           });

      return promise;
   }

   modelService.getResultModelList = function(selModel) {
      var url = "mongoclient.php";
      if(selModel != undefined && selModel != "")
      {
         url = "mongoclient.php?ModelName=" + selModel;
         modelService.SelectedResultModel = selModel;
      }

      var promise = $http.get(url);
            
      promise.then(function(response) {
         console.log("ModelList=" + response.data.ResultModelList);
               return response;
      },
      function(response) {
         console.log("ERROR=" + response.message);
      },
            function(response) {
         console.log("ERROR=" + response.message);
            });

            return promise;
      }

      modelService.getCollectionList = function(selectedResultModel) {
         var url = "mongocollectnames.php";
         if(selectedResultModel != undefined && selectedResultModel != "")
         {
            url = "mongocollectnames.php?ModelName=" + selectedResultModel;
         }
   
         var promise = $http.get(url);
               
         promise.then(function(response) {
            console.log("CollectionList=" + response.data.CollectionList);
                  return response;
         },
         function(response) {
            console.log("ERROR=" + response.message);
         },
               function(response) {
            console.log("ERROR=" + response.message);
               });
   
               return promise;
         }

   return modelService;
}]);


CAEApp.controller("modelImageController", ['$scope', '$http', 'ModelsService', '$window', function($scope, $http, ModelsService, $window) {
      $scope.modelList = [];
      $scope.kwDetailList = [];
      $scope.kwCountList = [];
      $scope.selectedModel = "";
      $scope.selectedResultModel = "";
      $scope.userDir = "";
      $scope.modelImagePath = "";
      $scope.jsDataDir = "";
      $scope.ResultsFlag = false;
      $scope.partTable = [];
      $scope.partAllCheck = {"pIndex":-1, "pState":true};

      ModelsService.getModelList().then(function (response) {
         $scope.selectedModel = response.data.SelectedModel;
         $scope.combinedModelList = [];
         for(var mIndex = 0; mIndex < response.data.ModelList.length; ++mIndex)
         {
            var obj = {};
            obj.name = response.data.ModelList[mIndex];
            obj.path = response.data.ModelPathList[mIndex];
            $scope.combinedModelList.push(obj);
         }
         $scope.userDir = response.data.UserDir;
         $scope.baseDir = response.data.BaseDir;
         $scope.modelImagePath = response.data.ImagePath;
         $scope.kwDetailList = response.data.kwDetailList;
         $scope.kwCountList = response.data.kwCountList;
         $scope.jsDataDir = response.data.jsDataDir;
         ModelsService.jsDataDir = $scope.jsDataDir;
         console.log("JS DATA DIR=" + ModelsService.jsDataDir);
         ModelsService.getPartList().then(function () {
         $scope.partTable = [];
         $scope.PDArray = ModelsService.PDArray;
         for(var i = 0; i < $scope.PDArray.length; i++)
         {
            $scope.partTable[i] = {"pIndex":i, "pState":true, "pSelect":false};
         }
         });
      },
      function (message) {
          console.log(message);
      });
      $scope.Init = function() {
         ModelsService.getResultModelList().then(function (response) {
            $scope.selectedResultModel = response.data.SelectedResultModel;
            $scope.resultModelList = response.data.ResultModelList;
            $scope.userDir = response.data.UserDir;
            $scope.jsDataDir = response.data.jsDataDir;
            ModelsService.jsDataDir = $scope.jsDataDir;
            globalJSResultDir = $scope.jsDataDir;
            globalTimeArray = response.data.TimeArray;
            console.log("JS DATA DIR=" + ModelsService.jsDataDir);
            ModelsService.getPartList().then(function () {
               $scope.partTable = [];
               $scope.PDArray = ModelsService.PDArray;
            for(var i = 0; i < $scope.PDArray.length; i++)
               {
                  $scope.partTable[i] = {"pIndex":i, "pState":true, "pSelect":false};
               }
            });
         },
         function (message) {
            console.log(message);
         });
      };

      $scope.onResultModelClick = function(selectedResultModel) {
         ModelsService.getResultModelList(selectedResultModel).then(function (response) {
         $scope.resultModelList = response.data.ResultModelList;
         $scope.selectedResultModel = response.data.SelectedResultModel;
         $scope.userDir = response.data.UserDir;
         $scope.jsDataDir = response.data.jsDataDir;
         $scope.TimeArray = response.data.TimeArray;
         globalStateScriptArray = [];
         for(var i = 0; i < globalScene.meshes.length; ++i) {
            if(globalScene.meshes[i].fn) {
               globalScene.unregisterBeforeRender(globalScene.meshes[i].fn);
            }
            globalScene.meshes[i].dispose();
            globalScene.meshes[i] = null;
         }
         globalScene.meshes = [];
         DownloadResultFiles($scope.jsDataDir, "0");
         for (var i = 0; i < $scope.TimeArray.length; ++i) {
            DownloadResultFiles($scope.jsDataDir, "" + (i + 1));
         }
         console.log("JS DATA DIR=" + $scope.jsDataDir);
            var dataDir = $scope.jsDataDir + "jsdata/0";
            ModelsService.getPartList(dataDir).then(function () {
               //$scope.partTable = [{"pIndex":0, "pState":true}];
               $scope.partTable = [];
               $scope.PDArray = ModelsService.PDArray;
            for(var i = 0; i < $scope.PDArray.length; i++)
               {
                  $scope.partTable[i] = {"pIndex":i, "pState":true, "pSelect":false};
               }
            });
         $scope.SwitchOnOffPart();
         console.log(response.data.Info);
     },
     function (message) {
         console.log(message);
     });
  };

   $scope.onModelClick = function(selectedModel) {
          ModelsService.getModelList(selectedModel).then(function (response) {
     $scope.combinedModelList = [{name: "", path:""}];
     for(var mIndex = 0; mIndex < response.data.ModelList.length; ++mIndex)
     {
         $scope.combinedModelList[mIndex].name = response.data.ModelList[mIndex];
         $scope.combinedModelList[mIndex].path = response.data.ModelPathList[mIndex];
     }
	  $scope.selectedModel = response.data.SelectedModel;
	  $scope.userDir = response.data.UserDir;
	  $scope.modelImagePath = response.data.ImagePath;
	  $scope.kwDetailList = response.data.kwDetailList;
	  $scope.kwCountList = response.data.kwCountList;
	  $scope.jsDataDir = response.data.jsDataDir;
      console.log(response.data.Info);
      },
      function (message) {
          console.log(message);
      });
   };
   $scope.onModelDetailsClick = function(selectedModel) {
      ModelsService.getModelDetails(selectedModel).then(function (response) {
      $scope.kwDetailList = response.data.kwDetailList;
      $scope.kwCountList = response.data.kwCountList;
      console.log(response.data.Info);
      },
      function (message) {
            console.log(message);
      });
   };
   $scope.SwitchOnOffPart = function(partIndex)   {
      console.log(" part=" + partIndex);
      if(partIndex >= 0)
      {
         var checkStatus = $scope.partTable[partIndex].pState;
         var meshName = "PART_" + partIndex;
         var meshObj = $window.globalScene.getMeshByName(meshName);
         if(meshObj)
            meshObj.setEnabled(checkStatus);
         $scope.partAllCheck.pState = true;
         for(var i = 0; i < $scope.partTable.length; i++)
         {
            if($scope.partTable[i].pState == true) {
               continue;
            }
            else {
               $scope.partAllCheck.pState = false;
               break;
            }
         }
      }
      else// if(partIndex != undefined)
      {
         var checkStatus = $scope.partAllCheck.pState;
         //starts from 1 as light location has another object
         for(var i = 0; i < $scope.partTable.length; i++)
         {
            var part_name = "PART_" + i;
            var part_obj = $window.globalScene.getMeshByName(part_name);
            if(part_obj)
               part_obj.setEnabled(checkStatus);
            $scope.partTable[i].pState = checkStatus;
         }
      }
   };
   
   $scope.ProcessDisplay = function(meshName, checkStatus) {
      if(meshName != undefined)
      {
         var meshObj = $window.globalScene.getMeshByName(meshName);
         if(meshObj)
            meshObj.setEnabled(checkStatus);
         return;
      }
      var flatShading = false;
      if($scope.Display.Shading == "Flat")
          flatShading  = true;
      
      for(var i = 0; i < globalScene.materials.length; i++)
      {
         if(!globalScene.meshes[i].isEnabled())
            continue;

         if(flatShading)
         {
            globalScene.meshes[i].convertToFlatShadedMesh();
            // globalScene.meshes[i].enableEdgesRendering(0.5);
            // globalScene.meshes[i].edgesColor.copyFromFloats(1, 1, 1, 1);
            // globalScene.meshes[i].edgesWidth = 5;
         }
         globalScene.materials[i].wireframe = $scope.Display.WireFrame ? true : false;
         globalScene.materials[i].alpha = $scope.Display.Transparent ? 0.5 : 1.0;
      }
   };

   $scope.UpdatePlots = function() {
      ModelsService.getCollectionList($scope.selectedResultModel).then(function (response) {
         $scope.plotCollectionList = response.data.CollectionList;
         $scope.selectedPlot = response.data.SelectedPlot;
         var jsDir = response.data.jsDataDir;
         DownloadPlotResultFiles(jsDir, $scope);
     },
     function (message) {
         console.log(message);
     });
   };

   $scope.UpdateSelectedPlot = function() {

      if(globalPlotEngine)
      {
         globalPlotScene.dispose();
         globalPlotScene = null;
         globalPlotEngine.dispose();
         globalPlotEngine = null;
      }
        var selectedPlot = $scope.selectedPlot.name;
        var canvas = document.getElementById('plotCanvas');
        var yData = null;
        var zData = ['PART 0'];
        switch($scope.selectedPlot.name)
        {
         case "Global Kinetic Energy":
            yData = arrGKE;
            break;
         case "Global Internal Energy":
            yData = arrGIE;
            break;
         case "Global Total Energy":
            yData = arrGTE;
            break;
         case "Global X Velocity":
            yData = arrGXVE;
            break;
         case "Global Y Velocity":
            yData = arrGYVE;
            break;
         case "Global Z Velocity":
            yData = arrGZVE;
            break;
        }

        var yPartData = null;
        switch($scope.selectedPlot.name)
        {
         case "Kinetic Energy":
            yPartData = KineticEnergy;
            break;
         case "Internal Energy":
            yPartData = InternalEnergy;
            break; 
         case "HourGlass Energy":
            yPartData = HourGlassEnergy;
            break;
         case "X Velocity":
            yPartData = XVelocity;
            break;
         case "Y Velocity":
            yPartData = YVelocity;
            break;
         case "Z Velocity":
            yPartData = ZVelocity;
            break;
        }

        var dataArray = [];
        if(yData)
        {
            for(i = 0; i < zData.length; ++i)
            {
                  for(j = 0; j < yData.length; ++j)
                  {
                     var obj = {};
                     obj.x = j;
                     obj.z = i;
                     obj.value = yData[j];
                     dataArray.push(obj);
                  }
            }
        }
        else if(yPartData)
        {
            zData = [];
            var allParts= [];
            for(i = 0; i < $scope.PDArray.length; ++i)
            {
               if($scope.partTable[i].pState == false)
                  allParts.push(0);
               else
                  allParts.push(1);

               var startPart = $scope.PDArray[i];
               var endPart = [];
               if(i < ($scope.PDArray.length-1))
                  endPart = $scope.PDArray[i+1];
               if(endPart.length == 0)
                  continue;
               var startId = startPart[0] +1;
               var endId = endPart[0];
               for(j = startId; j < endId; ++j)
               {
                  allParts.push(1);
               }
            }

            for(i = 0; i < yPartData.length; ++i)
            {
               if(allParts[i] == 0)
                  continue;
               zData.push("P " + (i+1));
               yData = yPartData[i];
               for(j = 0; j < yData.length; ++j)
               {
                  var obj = {};
                  obj.x = j;
                  obj.z = i;
                  obj.value = yData[j];
                  dataArray.push(obj);
               }
            }
        }

        var ticks = d3.ticks(d3.min(arrTS), d3.max(arrTS), arrTS.length);
            
        // HoloGraphV2(canvas, null); // to see default example
        
        HoloGraphV2(canvas, {
            type: 'line', // "line" or "bar", default = bar
            title: '3D Graph', // title on top of graph
            width: 15, // how wide is the graph in units (X-axis). default = 15
            // X-axis array of dates ex. MM/DD/YY or MM/DD/YYYY HH:mm
            dates: ticks,
            // Z-axis list of categories
            categories: zData,
            // array of data 
            // x = index of date on X-axis, ex. 0 to options.dates.length - 1
            // z = index of category on Z-axis, ex. 0 to options.categories.length - 1
            // value = Y-axis int or float Number value
            // if data = [], example values will be generated
            data: dataArray,
            /*[
            {x: 0, z:0, value: 742050944},
            {x: 1, z:0, value: 741049024},
            {x: 2, z:0, value: 734297664},
            {x: 3, z:0, value: 727842752},
            {x: 4, z:0, value: 721323328},
            {x: 5, z:0, value: 691436992},
            {x: 6, z:0, value: 630309504},
            {x: 7, z:0, value: 584550336},
            {x: 8, z:0, value: 569265792},
            {x: 9, z:0, value: 560331904},
            {x: 10, z:0, value: 554411584},
            {x: 11, z:0, value: 550824704},
            {x: 12, z:0, value: 548558464},
            {x: 13, z:0, value: 547112000},
            {x: 14, z:0, value: 546802240},
            {x: 15, z:0, value: 546681984},
            {x: 16, z:0, value: 546433344},
            {x: 17, z:0, value: 546123584},
            {x: 18, z:0, value: 545947328},
            {x: 19, z:0, value: 546196736},
            {x: 20, z:0, value: 546067456},
            {x: 21, z:0, value: 546069568}
            ],*/
            xTitle: 'Time Step',
            yTitle: selectedPlot,
            zTitle: 'Part IDs'
        });
   };

}]);
