var CAEApp = angular.module("CAEApp", []);

CAEApp.factory('ModelsService', ['$http', function($http) {
    var modelService = {};
    modelService.jsDataDir = "";
    modelService.getModelList = function(selModel) {
           var url = "getmodels.php";
           if(selModel != undefined && selModel != "")
           {
              url = "getmodels.php?ModelName=" + selModel;
              modelService.SelectedModel = selModel;
           }

	   var promise = $http.get(url);
           
	   promise.then(function(response) {
	      console.log("ModelList=" + response.data.ModelList);
              return response;
	   },
	   function(response) {
	      console.log("ERROR=" + response.message);
	   },
           function(response) {
	      console.log("ERROR=" + response.message);
           });

           return promise;
   }
   
   modelService.getPartList = function() {
      var url = this.jsDataDir + "/partdetails.js.gz";
      var promise = $http.get(url);

      promise.then(function(response) {
         //console.log("PartList=" + response.data);
         modelService.PDArray = response.data.PDArray;
              return response;
	   },
	   function(response) {
	      console.log("ERROR=" + response.message);
	   },
           function(response) {
	      console.log("ERROR=" + response.message);
           });

      return promise;
   }

   return modelService;
}]);


CAEApp.controller("modelImageController", ['$scope', '$http', 'ModelsService', '$window', function($scope, $http, ModelsService, $window) {
      $scope.modelList = [];
      $scope.kwDetailList = [];
      $scope.kwCountList = [];
      $scope.selectedModel = "";
      $scope.userDir = "";
      $scope.modelImagePath = "";
      $scope.jsDataDir = "";
      $scope.partTable = [{"pIndex":0, "pState":true}];
      $scope.partAllCheck = {"pIndex":-1, "pState":true};

      ModelsService.getModelList().then(function (response) {
	  $scope.selectedModel = response.data.SelectedModel;
	  $scope.modelList = response.data.ModelList;
	  $scope.userDir = response.data.UserDir;
	  $scope.modelImagePath = response.data.ImagePath;
	  $scope.kwDetailList = response.data.kwDetailList;
	  $scope.kwCountList = response.data.kwCountList;
     $scope.jsDataDir = response.data.jsDataDir;
     ModelsService.jsDataDir = $scope.jsDataDir;
     console.log("JS DATA DIR=" + ModelsService.jsDataDir);
     ModelsService.getPartList().then(function () {
         $scope.PDArray = ModelsService.PDArray;
         for(var i = 0; i < $scope.PDArray.length; i++)
         {
            $scope.partTable[i] = {"pIndex":i, "pState":true};
         }
         });
      },
      function (message) {
          console.log(message);
      });

   $scope.onModelClick = function(selectedModel) {
          ModelsService.getModelList(selectedModel).then(function (response) {
	  $scope.modelList = response.data.ModelList;
	  $scope.selectedModel = response.data.SelectedModel;
	  $scope.userDir = response.data.UserDir;
	  $scope.modelImagePath = response.data.ImagePath;
	  $scope.kwDetailList = response.data.kwDetailList;
	  $scope.kwCountList = response.data.kwCountList;
	  $scope.jsDataDir = response.data.jsDataDir;
console.log(response.data.Info);
      },
      function (message) {
          console.log(message);
      });
   };
   $scope.SwitchOnOffPart = function(partIndex)   {
      console.log(" part=" + partIndex);
      if(partIndex >= 0)
      {
         var checkStatus = $scope.partTable[partIndex].pState;
         $window.globalScene.meshes[partIndex].setEnabled(checkStatus);
         $scope.partAllCheck.pState = true;
         for(var i = 0; i < $scope.partTable.length; i++)
         {
            if($scope.partTable[i].pState == true) {
               continue;
            }
            else {
               $scope.partAllCheck.pState = false;
               break;
            }
         }
      }
      else if(partIndex != undefined)
      {
         var checkStatus = $scope.partAllCheck.pState;
         //starts from 1 as light location has another object
         for(var i = 0; i < globalScene.meshes.length; i++)
         {
            $window.globalScene.meshes[i].setEnabled(checkStatus);
            $scope.partTable[i].pState = checkStatus;
         }
      }
   }
   
   $scope.ProcessDisplay = function(name, value) {
      console.log(name + "=" + value);
      $scope.modelImagePath = "";
      var url = "updateconnfile.php?" + name + "=" + value;
      $http.get(url)
      .then(function(response) {
         console.log(response.data);
         $scope.modelImagePath = "http://" + $window.location.hostname + "/" + response.data.modelImagePath;
           });
   }

}]);
