function MouseInteractor(canvas){

    this.canvas = canvas;


    this.dragging = false;
    this.x = 0;
    this.y = 0;
    this.lastX = 0;
    this.lastY = 0;
    this.button = 0;
    this.shift = false;
    this.key = 0;
    this.zoom = 0.0;
    this.rotX = 0.0;
    this.rotY = 0.0;
    this.rotZ = 0.0;

    this.SENSITIVITY = 0.7;
    this.setUp();
}
MouseInteractor.prototype.setUp=function(){
    var self=this;
    this.canvas.onmousedown = function(ev) {
        self.onMouseDown(ev);
    }

    this.canvas.onmouseup = function(ev) {
        self.onMouseUp(ev);
    }

    this.canvas.onmousemove = function(ev) {
        self.onMouseMove(ev);
    }
}

MouseInteractor.prototype.onMouseUp = function(evnt){
    this.dragging = false;
    drawModel();
}

MouseInteractor.prototype.onMouseDown = function(evnt){
    this.dragging = true;
    this.lastX = evnt.clientX;
    this.lastY = evnt.clientY;
console.log("LAST="+this.lastX + " " + this.lastY);
    this.button = evnt.button;
}

MouseInteractor.prototype.onMouseMove = function(event){
    this.x = event.clientX;
    this.y = event.clientY;

    if (!this.dragging) return;
    this.shift = event.shiftKey;

    if (this.button == 0) {
        if(this.shift){
            var dx=this.mousePosX(this.x) -this.mousePosX(this.lastX)
            var dy=this.mousePosY(this.y) -this.mousePosY(this.lastY)

            this.rotate(dx,dy);
        }
        else{
console.log("LAST=" + this.lastY + " " + this.y);
            var dy = this.y - this.lastY;
            this.translate(dy);
        }
    }

}
MouseInteractor.prototype.mousePosX=function(x){
    return 2 * (x / this.canvas.width) - 1;
}
MouseInteractor.prototype.mousePosY=function(y){
    return 2 * (y / this.canvas.height) - 1;
}

MouseInteractor.prototype.translate = function(value){

console.log("TRANS="+value);
    var translateSensitivity=this.SENSITIVITY;
    this.zoom = (translateSensitivity * value / this.canvas.height);
console.log("ZOOM=" + this.zoom);
}

MouseInteractor.prototype.rotate = function(dx, dy){
    this.rotY = 10 * this.SENSITIVITY*dx;
    this.rotX = 10 * this.SENSITIVITY*dy;
console.log("ROT X=" + this.rotX);
console.log("ROT Y=" + this.rotY);
}

