var xmlHttp;
function getXmlHttpObject()
{
   var xmlHttp = null;

   try
   {
      //firefox, opera 8.0+, safari
      xmlHttp = new XMLHttpRequest();
   }
   catch (e)
   {
      //IE
      try
      {
         xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
      }
      catch (e)
      {
         xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
      }
   }

   return xmlHttp;
}

function sendRequest(url, model_name)
{
   xmlHttp = getXmlHttpObject();

   if( xmlHttp == null )
   {
      console.log("Your browser does not support AJAX");
      return;
   }

   url += "?FEMODEL_NAME='" + model_name + "'";
//alert("URL = " + url);
   xmlHttp.onreadystatechange = updateDB;
   xmlHttp.open("GET", url, true);
   xmlHttp.send(null);
}

function updateDB()
{
   if( xmlHttp.readyState == 4 )
   {
//alert("STATE = 4");
      //document.getElementById("statusDiv").innerHTML = xmlHttp.responseText;
      //drawModel();
   }
}

function setupWebGL()
{
   glCanvas.clearColor(0.0, 0.0, 0.0, 1.0);
   glCanvas.clear(glCanvas.COLOR_BUFFER_BIT | glCanvas.DEPTH_BUFFER_BIT);
   glCanvas.enable(glCanvas.DEPTH_TEST);
}

function getMatrixUniforms()
{
   glProgram.vertexPositionAttribute = glCanvas.getAttribLocation(glProgram,"aVertexPosition");
   glCanvas.enableVertexAttribArray(glProgram.vertexPositionAttribute);
   glProgram.vertexNormalAttribute = glCanvas.getAttribLocation(glProgram,"aVertexNormal");
   glCanvas.enableVertexAttribArray(glProgram.vertexNormalAttribute);


   glProgram.uWorldViewProjection = glCanvas.getUniformLocation(glProgram,"uWorldViewProjection");
   glProgram.uWorldInverseTranspose = glCanvas.getUniformLocation(glProgram,"uWorldInverseTranspose");

   glProgram.uColor = glCanvas.getUniformLocation(glProgram,"uColor");
   glProgram.uReverseLightDirection = glCanvas.getUniformLocation(glProgram,"uReverseLightDirection");
}

function setMatrixUniforms()
{
   var worldViewProjectionMatrix = mat4.create();
   mat4.multiply(worldViewProjectionMatrix, pMatrix, mvMatrix);
   var invertMatrix = mat4.create();
   mat4.invert(invertMatrix, mvMatrix);
   var worldInverseTransposeMatrix = mat4.create();
   mat4.transpose(worldInverseTransposeMatrix, invertMatrix);
   glCanvas.uniformMatrix4fv(glProgram.uWorldViewProjection, false, worldViewProjectionMatrix);
   glCanvas.uniformMatrix4fv(glProgram.uWorldInverseTranspose, false, worldInverseTransposeMatrix);
   var lightDirection = vec3.fromValues(0.0, 0.0, 1.0);
   vec3.normalize(lightDirection, lightDirection);
   glCanvas.uniform3fv(glProgram.uReverseLightDirection, lightDirection);
}

function makeShader(src, type)
{
   var shader = glCanvas.createShader(type);
   glCanvas.shaderSource(shader, src);
   glCanvas.compileShader(shader);


   if(!glCanvas.getShaderParameter(shader, glCanvas.COMPILE_STATUS) && 
	!glCanvas.isContextLost())
   {
      console.log("Error compiling shader: " + glCanvas.getShaderInfoLog(shader));
   }

   return shader;
}

function initShaders()
{
   var vs_source = null, fs_source = null;

var num_vertex = glCanvas.getParameter(glCanvas.MAX_VERTEX_UNIFORM_VECTORS);
var num_frag = glCanvas.getParameter(glCanvas.MAX_FRAGMENT_UNIFORM_VECTORS);
var num_buffers = glCanvas.getParameter(glCanvas.ARRAY_BUFFER_BINDING);
console.log("NUM VERTEX=" + num_vertex + " NUM FRAG=" + num_frag + "NUM BUFF=" + num_buffers);

   $.ajax(
	   {
	      async: false,
	      url: 'js/model.vs',
	      success: function (data)
	      {
console.log("VERTEX SRC=" + data.firstChild.textContent);
		 //vs_source = data.firstChild.textContent;
		 vs_source = data.firstChild.textContent;
//console.log("VERTEX SRC=" + vs_source);
	      }, 
	      dataType: 'xml',
	      error: errorFunc 
	   }
        );

console.log("vertex shader");
   vertexShader = makeShader(vs_source, glCanvas.VERTEX_SHADER);

   $.ajax(
           {
              async: false,
              url: 'js/model.fs',
              success: function(data)
              {
console.log("FRAGMENT SRC=" + data.firstChild.textContent);
                 fs_source = data.firstChild.textContent;
//console.log("fragment SRC=" + fs_source);
              },
              dataType: 'xml',
	      error: errorFunc 
           }
         );


console.log("fragment shader");
   fragmentShader = makeShader(fs_source, glCanvas.FRAGMENT_SHADER);

   glProgram = glCanvas.createProgram();
   
   glCanvas.attachShader(glProgram, vertexShader);
   glCanvas.attachShader(glProgram, fragmentShader);

   glCanvas.linkProgram(glProgram);

   var linked = glCanvas.getProgramParameter(glProgram, glCanvas.LINK_STATUS);
   if(!linked && !glCanvas.isContextLost())
   {
      var infoLog = glCanvas.getProgramInfoLog(glProgram);
      console.log("Unable to initialize the shader program." + infoLog);
   }

   //var result = getProgramInfo(glCanvas, glProgram);
console.log("INFO");
   //console.table(result);

   glCanvas.useProgram(glProgram);
   getMatrixUniforms();
}

function setLightUniform()
{
   var light = new Light();
   light.ambientColor = [0.1,0.1,0.1];
   light.diffuseColor = [0.9,0.9,0.9];
   light.specularColor = [0.9,0.9,0.9];
   light.direction = [1.0,1.0,1.0];

   var light1 = new Light();
   light1.diffuseColor = [lightColor[0],lightColor[1],lightColor[2]];
   light1.specularColor = [0.0,0.0,0.0];
   light1.position = [1837.89,-4567.41,-1844.87];

   var light2 = new Light();
   light2.diffuseColor = [1.0,1.0,1.0];
   light2.specularColor = [0.0,0.0,0.0];
   light2.position = [9134.81,2336,3689.75];

   var lights = new Lights();
   lights.addLight(light);
   //lights.addLight(light1);
   //lights.addLight(light2);

   glCanvas.uniform3fv(glProgram.uLightPosition,lights.getDataByType("position"));
   glCanvas.uniform3fv(glProgram.uLightDirection, lights.getDataByType("direction"));
}

function drawScene()
{
   if(iBALength[0] == undefined)
       return;
   //setLightUniform();
   setMatrixUniforms();
   for(i = 0; i < NUM_PARTS; i++)
   {
      //glCanvas.uniform4f(glProgram.vertexColorUniform, pCA[i][0], pCA[i][1], pCA[i][2], pCA[i][3]);
      glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER, vBA[i]);
//console.log(fBA[i]);
      //glCanvas.bufferData(glCanvas.ARRAY_BUFFER, fBA[i], glCanvas.STATIC_DRAW);
      glCanvas.vertexAttribPointer(glProgram.vertexPositionAttribute, 3, glCanvas.FLOAT, false, 0, 0);
      glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER, vNA[i]);
      glCanvas.vertexAttribPointer(glProgram.vertexNormalAttribute, 3, glCanvas.FLOAT, false, 0, 0);
      glCanvas.uniform4f(glProgram.uColor, pCA[i][0], pCA[i][1], pCA[i][2], pCA[i][3]);

      if(iBA[i] && iBALength[i])
      {
console.log("IDEX=" + i);
         glCanvas.bindBuffer(glCanvas.ELEMENT_ARRAY_BUFFER, iBA[i]);
//console.log(iAR[i]);
      //glCanvas.bufferData(glCanvas.ELEMENT_ARRAY_BUFFER, iAR[i], glCanvas.STATIC_DRAW);
         glCanvas.drawElements(glCanvas.TRIANGLES, iBALength[i], glCanvas.UNSIGNED_SHORT, 0);
      }
      glCanvas.bindBuffer(glCanvas.ARRAY_BUFFER, null);
      //glCanvas.bindBuffer(glCanvas.ELEMENT_ARRAY_BUFFER, null);
   }
}

function pushMatrix() 
{
      var copy = mat4.create();
      mat4.copy(copy,mvMatrix);
      matrixStack.push(copy);
}

function popMatrix()
{
      if (matrixStack.length == 0) 
      {
          throw "Invalid popMatrix!";
      }

      mvMatrix = matrixStack.pop();
}

function degToRad(degrees)
{
      return degrees * Math.PI / 180;
}

function calculateVertexNormals(vertices, indices, normals)
{
   var vertexVectors = [];
   var normalVectors = [];

   var j;
   for(var i = 0; i < vertices.length; i = i + 3)
   {
      var vector = vec3.fromValues(vertices[i], vertices[i+1], vertices[i+2]);
      var normal = vec3.create();
      normalVectors.push(normal);
      vertexVectors.push(vector);
   }

   for(j = 0; j < indices.length; j = j + 3)
   {
      //v1-v0
      var vector1 = vec3.create();
      vec3.subtract(vector1, vertexVectors[indices[j+1]], vertexVectors[indices[j]]);
      //v2-v1
      var vector2 = vec3.create();
      vec3.subtract(vector2, vertexVectors[indices[j+2]], vertexVectors[indices[j+1]]);

      var normal = vec3.create();
      //cross product of two vectors
      vec3.cross(normal, vector1, vector2);

      vec3.add(normalVectors[indices[j]], normalVectors[indices[j]], normal);
      vec3.add(normalVectors[indices[j+1]], normalVectors[indices[j+1]], normal);
      vec3.add(normalVectors[indices[j+2]], normalVectors[indices[j+2]], normal);
   }

   for(j = 0; j < normalVectors.length; j = j + 1)
   {
      vec3.normalize(normalVectors[j], normalVectors[j]);
      normals.push(normalVectors[j][0]);
      normals.push(normalVectors[j][1]);
      normals.push(normalVectors[j][2]);
   }
}

function handleContextLost(event)
{
   event.preventDefault();
   cancelAnimationFrame(animReqId);
}

function getProgramInfo(gl, program) 
{
    var result = {
        attributes: [],
        uniforms: [],
        attributeCount: 0,
        uniformCount: 0
    },
    activeUniforms = gl.getProgramParameter(program, gl.ACTIVE_UNIFORMS),
    activeAttributes = gl.getProgramParameter(program, gl.ACTIVE_ATTRIBUTES);

    // Taken from the WebGl spec:
    // http://www.khronos.org/registry/webgl/specs/latest/1.0/#5.14
    var enums = {
        0x8B50: 'FLOAT_VEC2',
        0x8B51: 'FLOAT_VEC3',
        0x8B52: 'FLOAT_VEC4',
        0x8B53: 'INT_VEC2',
        0x8B54: 'INT_VEC3',
        0x8B55: 'INT_VEC4',
        0x8B56: 'BOOL',
        0x8B57: 'BOOL_VEC2',
        0x8B58: 'BOOL_VEC3',
        0x8B59: 'BOOL_VEC4',
        0x8B5A: 'FLOAT_MAT2',
        0x8B5B: 'FLOAT_MAT3',
        0x8B5C: 'FLOAT_MAT4',
        0x8B5E: 'SAMPLER_2D',
        0x8B60: 'SAMPLER_CUBE',
        0x1400: 'BYTE',
        0x1401: 'UNSIGNED_BYTE',
        0x1402: 'SHORT',
        0x1403: 'UNSIGNED_SHORT',
        0x1404: 'INT',
        0x1405: 'UNSIGNED_INT',
        0x1406: 'FLOAT'
    };

    // Loop through active uniforms
    for (var i=0; i < activeUniforms; i++) {
        var uniform = gl.getActiveUniform(program, i);
        uniform.typeName = enums[uniform.type];
        result.uniforms.push(uniform);
        result.uniformCount += uniform.size;
    }

    // Loop through active attributes
    for (var i=0; i < activeAttributes; i++) {
        var attribute = gl.getActiveAttrib(program, i);
        attribute.typeName = enums[attribute.type];
        result.attributes.push(attribute);
        result.attributeCount += attribute.size;
    }

    return result;
}

