<?php
    header('Cache-Control: no-cache, must-revalidate');
    header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
    header('Pragma: no-cache');
    header('Content-Type: application/json');

    $qry_str = $_SERVER['QUERY_STRING'];
    parse_str($qry_str, $qry_array);
include_once( 'lsdyna/lsd.php');

    if($qry_array)
    {
        $model_name = $qry_array["ModelName"];
        if($model_name)
        {
            $db_name = "caedb";
            setValue("DBFrame", "Gui", $db_name, $model_name);
        }
    }

    $manager = new \MongoDB\Driver\Manager();
    $model_array = Array();
    try
    {
        $coll = "caedb.models";
        $filter = [];
        $options = [];
        $query = new \MongoDB\Driver\Query($filter, $options);
        $rows = $manager->executeQuery($coll, $query);
        foreach($rows as $document)
        {
            $doc = (array)$document;
            $id = (string)$doc['_id'];
            $model = (string)$doc['model'];
            array_push($model_array, $model);
            //echo $model . "\n";
        }
    }
    catch(\MongoDB\Driver\Exception $e)
    {
        echo $e->getMessage(), "\n";
        exit;
    }

    if(isset($_SERVER['PHP_AUTH_USER']))
       $app_user = $_SERVER['PHP_AUTH_USER'];
    else
    {
       $app_user = "raj";
       $_SERVER['PHP_AUTH_USER'] = $app_user;
    }

    $app_user = $_SERVER['PHP_AUTH_USER'];


    $num_models = count($model_array);
    $db_name = "caedb";
    $model_name = getVarValue("DBFrame", "Gui", "$db_name");

    if( $model_name == null && $num_models != 0 )
    {
       $model_name = $model_array[0];
       setValue("DBFrame", "Gui", $db_name, $model_name);
    }

    $js_dir = "/TEMP/$app_user/$db_name/$model_name/";
    $user_dir = "TEMP/$app_user/$db_name";
    $res_array["ResultModelList"] = $model_array;
    $res_array["UserDir"] = $user_dir;
    $res_array["SelectedResultModel"] = $model_name;
    $res_array["jsDataDir"] = $js_dir;

    $coll = "caedb.models";
    $filter = ['model'=>$model_name];
    $options = [];
    $query = new \MongoDB\Driver\Query($filter, $options);
    $cursor = $manager->executeQuery($coll, $query);
    $cursor->setTypeMap(['root' => 'array']);
    $model_id = "";
    foreach($cursor as $document)
    {
        $model_id = $document["_id"];
        //echo $model_id . "\n";
    }

    $coll = "caedb.users";
    $filter = ['user'=>"kmarichetty@gmail.com"];
    $options = [];
    $query = new \MongoDB\Driver\Query($filter, $options);
    $cursor = $manager->executeQuery($coll, $query);
    $cursor->setTypeMap(['root' => 'array']);
    $user_id = "";
    foreach($cursor as $document)
    {
        $user_id = $document["_id"];
        //echo $user_id . "\n";
    }

    #$connection = new MongoDB\Driver\Manager("mongodb://localhost:27017/?minPoolSize=3&maxPoolSize=9");
    $coll = "caedb.Time Steps";
    $filter = ["modelid"=>"$model_id", "userid"=>"$user_id"];
    $options = [];
    $query = new \MongoDB\Driver\Query($filter, $options);
    $cursor = $manager->executeQuery($coll, $query);
    $cursor->setTypeMap(['root' => 'array']);

    $time_array = Array();
    foreach($cursor as $item)
    {
	    //print_r($item);
        if(isset($item["arrTS"]))
        {
            foreach($item as $step)
            {
                if(is_array($step) === FALSE)
                    continue;
                foreach($step as $time)
                {
                    array_push($time_array, $time);
                }
            }
        }
    }
    $res_array["TimeArray"] = $time_array;

    echo json_encode($res_array);
?>
